import { Plugin } from 'vue';
import Item, { ListItemMeta } from './Item';
export { ListItemProps, ListItemMetaProps, ListItemMeta } from './Item';
export declare const ColumnCount: (string | number)[];
export declare const ColumnType: string[];
export declare const ListGridType: {
    gutter: import("vue-types").VueTypeValidableDef<number> & {
        default: number;
    };
    column: import("vue-types").VueTypeDef<string | number>;
    xs: import("vue-types").VueTypeDef<string | number>;
    sm: import("vue-types").VueTypeDef<string | number>;
    md: import("vue-types").VueTypeDef<string | number>;
    lg: import("vue-types").VueTypeDef<string | number>;
    xl: import("vue-types").VueTypeDef<string | number>;
    xxl: import("vue-types").VueTypeDef<string | number>;
};
export declare const ListSize: ["small", "default", "large"];
export declare const ListProps: () => {
    bordered: import("vue-types").VueTypeValidableDef<boolean>;
    dataSource: import("vue-types").VueTypeValidableDef<unknown[]> & {
        default: () => unknown[];
    };
    extra: import("vue-types").VueTypeValidableDef<any>;
    grid: import("vue-types").VueTypeLooseShape<{
        gutter: (number | ((props: Record<string, unknown>) => number)) & number;
        column: string | number;
        xs: string | number;
        sm: string | number;
        md: string | number;
        lg: string | number;
        xl: string | number;
        xxl: string | number;
    }>;
    itemLayout: import("vue-types").VueTypeValidableDef<string> & {
        default: string;
    };
    loading: import("vue-types").VueTypeDef<boolean | {
        [key: string]: any;
    }>;
    loadMore: import("vue-types").VueTypeValidableDef<any>;
    pagination: import("vue-types").VueTypeDef<boolean | Partial<{
        locale: {
            [key: string]: any;
        };
        onChange: (...args: any[]) => any;
        prefixCls: string;
        role: string;
        current: number;
        size: string;
        showSizeChange: (...args: any[]) => any;
        total: number;
        defaultCurrent: number;
        defaultPageSize: number;
        pageSize: number;
        buildOptionText: (...args: any[]) => any;
        selectPrefixCls: string;
        itemRender: (...args: any[]) => any;
        onShowSizeChange: (...args: any[]) => any;
        "onUpdate:current": (...args: any[]) => any;
        "onUpdate:pageSize": (...args: any[]) => any;
    } & {
        disabled?: boolean;
        hideOnSinglePage?: boolean;
        showSizeChanger?: boolean;
        pageSizeOptions?: (string | number)[];
        showQuickJumper?: boolean | {
            [key: string]: any;
        };
        showTotal?: any;
        simple?: boolean;
        showLessItems?: boolean;
        position?: "both" | "bottom" | "top";
    }>>;
    prefixCls: import("vue-types").VueTypeValidableDef<string> & {
        default: string;
    };
    rowKey: import("vue-types").VueTypeValidableDef<any>;
    renderItem: import("vue-types").VueTypeValidableDef<any>;
    size: import("vue-types").VueTypeDef<"default" | "small" | "large">;
    split: import("vue-types").VueTypeValidableDef<boolean>;
    header: import("vue-types").VueTypeValidableDef<any>;
    footer: import("vue-types").VueTypeValidableDef<any>;
    locale: import("vue-types").VueTypeValidableDef<{
        [key: string]: any;
    }> & {
        default: () => {
            [key: string]: any;
        };
    };
};
declare const _default: {
    new (...args: any[]): {
        $: import("vue").ComponentInternalInstance;
        $data: {
            paginationCurrent: number;
            paginationSize: number;
        };
        $props: Partial<{
            locale: {
                [key: string]: any;
            };
            prefixCls: string;
            dataSource: unknown[];
            itemLayout: string;
        }> & Omit<Readonly<{
            locale: {
                [key: string]: any;
            };
            prefixCls: string;
            dataSource: unknown[];
            itemLayout: string;
        } & {
            footer?: any;
            header?: any;
            grid?: {
                gutter: (number | ((props: Record<string, unknown>) => number)) & number;
                column: string | number;
                xs: string | number;
                sm: string | number;
                md: string | number;
                lg: string | number;
                xl: string | number;
                xxl: string | number;
            };
            size?: "default" | "small" | "large";
            renderItem?: any;
            split?: boolean;
            loading?: boolean | {
                [key: string]: any;
            };
            bordered?: boolean;
            pagination?: boolean | Partial<{
                locale: {
                    [key: string]: any;
                };
                onChange: (...args: any[]) => any;
                prefixCls: string;
                role: string;
                current: number;
                size: string;
                showSizeChange: (...args: any[]) => any;
                total: number;
                defaultCurrent: number;
                defaultPageSize: number;
                pageSize: number;
                buildOptionText: (...args: any[]) => any;
                selectPrefixCls: string;
                itemRender: (...args: any[]) => any;
                onShowSizeChange: (...args: any[]) => any;
                "onUpdate:current": (...args: any[]) => any;
                "onUpdate:pageSize": (...args: any[]) => any;
            } & {
                disabled?: boolean;
                hideOnSinglePage?: boolean;
                showSizeChanger?: boolean;
                pageSizeOptions?: (string | number)[];
                showQuickJumper?: boolean | {
                    [key: string]: any;
                };
                showTotal?: any;
                simple?: boolean;
                showLessItems?: boolean;
                position?: "both" | "bottom" | "top";
            }>;
            rowKey?: any;
            extra?: any;
            loadMore?: any;
        }> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "locale" | "prefixCls" | "dataSource" | "itemLayout">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>>;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}>>;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<{
            locale: {
                [key: string]: any;
            };
            prefixCls: string;
            dataSource: unknown[];
            itemLayout: string;
        } & {
            footer?: any;
            header?: any;
            grid?: {
                gutter: (number | ((props: Record<string, unknown>) => number)) & number;
                column: string | number;
                xs: string | number;
                sm: string | number;
                md: string | number;
                lg: string | number;
                xl: string | number;
                xxl: string | number;
            };
            size?: "default" | "small" | "large";
            renderItem?: any;
            split?: boolean;
            loading?: boolean | {
                [key: string]: any;
            };
            bordered?: boolean;
            pagination?: boolean | Partial<{
                locale: {
                    [key: string]: any;
                };
                onChange: (...args: any[]) => any;
                prefixCls: string;
                role: string;
                current: number;
                size: string;
                showSizeChange: (...args: any[]) => any;
                total: number;
                defaultCurrent: number;
                defaultPageSize: number;
                pageSize: number;
                buildOptionText: (...args: any[]) => any;
                selectPrefixCls: string;
                itemRender: (...args: any[]) => any;
                onShowSizeChange: (...args: any[]) => any;
                "onUpdate:current": (...args: any[]) => any;
                "onUpdate:pageSize": (...args: any[]) => any;
            } & {
                disabled?: boolean;
                hideOnSinglePage?: boolean;
                showSizeChanger?: boolean;
                pageSizeOptions?: (string | number)[];
                showQuickJumper?: boolean | {
                    [key: string]: any;
                };
                showTotal?: any;
                simple?: boolean;
                showLessItems?: boolean;
                position?: "both" | "bottom" | "top";
            }>;
            rowKey?: any;
            extra?: any;
            loadMore?: any;
        }>, {
            keys: any[];
            defaultPaginationProps: {};
            onPaginationChange: any;
            onPaginationShowSizeChange: any;
            configProvider: import("../config-provider").ConfigConsumerProps;
        }, {
            paginationCurrent: number;
            paginationSize: number;
        }, {}, {
            triggerPaginationEvent(eventName: any): (page: any, pageSize: any) => void;
            innerRenderItem(item: any, index: any): any;
            isSomethingAfterLastItem(): boolean;
            renderEmpty(prefixCls: any, renderEmpty: any): JSX.Element;
        }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, {
            locale: {
                [key: string]: any;
            };
            prefixCls: string;
            dataSource: unknown[];
            itemLayout: string;
        }>;
        $forceUpdate: import("vue").ReactiveEffect<any>;
        $nextTick: typeof import("vue").nextTick;
        $watch(source: string | Function, cb: Function, options?: import("vue").WatchOptions<boolean>): import("vue").WatchStopHandle;
    } & Readonly<{
        locale: {
            [key: string]: any;
        };
        prefixCls: string;
        dataSource: unknown[];
        itemLayout: string;
    } & {
        footer?: any;
        header?: any;
        grid?: {
            gutter: (number | ((props: Record<string, unknown>) => number)) & number;
            column: string | number;
            xs: string | number;
            sm: string | number;
            md: string | number;
            lg: string | number;
            xl: string | number;
            xxl: string | number;
        };
        size?: "default" | "small" | "large";
        renderItem?: any;
        split?: boolean;
        loading?: boolean | {
            [key: string]: any;
        };
        bordered?: boolean;
        pagination?: boolean | Partial<{
            locale: {
                [key: string]: any;
            };
            onChange: (...args: any[]) => any;
            prefixCls: string;
            role: string;
            current: number;
            size: string;
            showSizeChange: (...args: any[]) => any;
            total: number;
            defaultCurrent: number;
            defaultPageSize: number;
            pageSize: number;
            buildOptionText: (...args: any[]) => any;
            selectPrefixCls: string;
            itemRender: (...args: any[]) => any;
            onShowSizeChange: (...args: any[]) => any;
            "onUpdate:current": (...args: any[]) => any;
            "onUpdate:pageSize": (...args: any[]) => any;
        } & {
            disabled?: boolean;
            hideOnSinglePage?: boolean;
            showSizeChanger?: boolean;
            pageSizeOptions?: (string | number)[];
            showQuickJumper?: boolean | {
                [key: string]: any;
            };
            showTotal?: any;
            simple?: boolean;
            showLessItems?: boolean;
            position?: "both" | "bottom" | "top";
        }>;
        rowKey?: any;
        extra?: any;
        loadMore?: any;
    }> & import("vue").ShallowUnwrapRef<{
        keys: any[];
        defaultPaginationProps: {};
        onPaginationChange: any;
        onPaginationShowSizeChange: any;
        configProvider: import("../config-provider").ConfigConsumerProps;
    }> & {
        paginationCurrent: number;
        paginationSize: number;
    } & {} & {
        triggerPaginationEvent(eventName: any): (page: any, pageSize: any) => void;
        innerRenderItem(item: any, index: any): any;
        isSomethingAfterLastItem(): boolean;
        renderEmpty(prefixCls: any, renderEmpty: any): JSX.Element;
    } & import("vue").ComponentCustomProperties;
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
} & import("vue").ComponentOptionsBase<Readonly<{
    locale: {
        [key: string]: any;
    };
    prefixCls: string;
    dataSource: unknown[];
    itemLayout: string;
} & {
    footer?: any;
    header?: any;
    grid?: {
        gutter: (number | ((props: Record<string, unknown>) => number)) & number;
        column: string | number;
        xs: string | number;
        sm: string | number;
        md: string | number;
        lg: string | number;
        xl: string | number;
        xxl: string | number;
    };
    size?: "default" | "small" | "large";
    renderItem?: any;
    split?: boolean;
    loading?: boolean | {
        [key: string]: any;
    };
    bordered?: boolean;
    pagination?: boolean | Partial<{
        locale: {
            [key: string]: any;
        };
        onChange: (...args: any[]) => any;
        prefixCls: string;
        role: string;
        current: number;
        size: string;
        showSizeChange: (...args: any[]) => any;
        total: number;
        defaultCurrent: number;
        defaultPageSize: number;
        pageSize: number;
        buildOptionText: (...args: any[]) => any;
        selectPrefixCls: string;
        itemRender: (...args: any[]) => any;
        onShowSizeChange: (...args: any[]) => any;
        "onUpdate:current": (...args: any[]) => any;
        "onUpdate:pageSize": (...args: any[]) => any;
    } & {
        disabled?: boolean;
        hideOnSinglePage?: boolean;
        showSizeChanger?: boolean;
        pageSizeOptions?: (string | number)[];
        showQuickJumper?: boolean | {
            [key: string]: any;
        };
        showTotal?: any;
        simple?: boolean;
        showLessItems?: boolean;
        position?: "both" | "bottom" | "top";
    }>;
    rowKey?: any;
    extra?: any;
    loadMore?: any;
}>, {
    keys: any[];
    defaultPaginationProps: {};
    onPaginationChange: any;
    onPaginationShowSizeChange: any;
    configProvider: import("../config-provider").ConfigConsumerProps;
}, {
    paginationCurrent: number;
    paginationSize: number;
}, {}, {
    triggerPaginationEvent(eventName: any): (page: any, pageSize: any) => void;
    innerRenderItem(item: any, index: any): any;
    isSomethingAfterLastItem(): boolean;
    renderEmpty(prefixCls: any, renderEmpty: any): JSX.Element;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, {
    locale: {
        [key: string]: any;
    };
    prefixCls: string;
    dataSource: unknown[];
    itemLayout: string;
}> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Plugin & {
    readonly Item: typeof Item & {
        readonly Meta: typeof ListItemMeta;
    };
};
export default _default;
